#!/bin/bash

if [ $# -ne 3 ]; then
	echo "usage: $0 src_base_dir build_base_dir install_base_dir"
	exit
fi

src_base_dir=$1
build_base_dir=$2
install_base_dir=$3


kern_ver="`uname -r`"
curdir=`pwd`

mkdir -p ${build_base_dir}/${kern_ver}/ihk
mkdir -p ${build_base_dir}/${kern_ver}/mckernel

# Make configure of IHK read list of addresses of internal functions
sudo chmod og+r /boot/System.map-`uname -r`

cd ${build_base_dir}/${kern_ver}/ihk/
${src_base_dir}/ihk/configure --prefix=${install_base_dir}/ --with-target=smp-x86

cd ${build_base_dir}/${kern_ver}/mckernel
${src_base_dir}/mckernel/configure --prefix=${install_base_dir}/ --with-target=smp-x86

cd ${build_base_dir}/${kern_ver}/ihk
if ! make clean || ! make -j40 || ! make install; then
	cd ${curdir}
	exit
fi

# Allow squashed root to create directories/files 
chmod o+w ${install_base_dir}/{kmod,bin,smp-x86,etc}

cd ${build_base_dir}/${kern_ver}/mckernel
if ! make clean || ! make -j40 || ! sudo make install; then
	cd ${curdir}
	exit
fi

cd ${curdir}
